## dune-istl 2.11.0

=== CMakeLists.txt ===
# SPDX-FileCopyrightText: Copyright © DUNE Project contributors, see file LICENSE.md in module root
# SPDX-License-Identifier: LicenseRef-GPL-2.0-only-with-DUNE-exception

cmake_minimum_required(VERSION 3.16)
project(dune-istl C CXX)

# guess build tree of dune-common
if(NOT (dune-common_DIR OR dune-common_ROOT OR
        "${CMAKE_PREFIX_PATH}" MATCHES ".*dune-common.*"))
    string(REPLACE  ${CMAKE_PROJECT_NAME} dune-common dune-common_DIR
      ${PROJECT_BINARY_DIR})

endif()

#find dune-common and set the module path
find_package(dune-common REQUIRED)
list(APPEND CMAKE_MODULE_PATH ${dune-common_MODULE_PATH}
  "${PROJECT_SOURCE_DIR}/cmake/modules")

#include the dune macros
include(DuneMacros)

# deactivate global include-directories
dune_policy(SET DP_DEFAULT_INCLUDE_DIRS NEW)

# deactivate global calls to add_dune_all_flags in tests
dune_policy(SET DP_TEST_ADD_ALL_FLAGS NEW)

# do not make all suggested dependencies required automatically
dune_policy(SET DP_SUGGESTED_MODULE_DEPENDENCIES_REQUIRED_DOWNSTREAM NEW)

# start a dune project with information from dune.module
dune_project()

# create library target and export it as Dune::ISTL
dune_add_library(duneistl INTERFACE
  EXPORT_NAME ISTL
  LINK_LIBRARIES Dune::Common)

# set include directories to target
dune_default_include_directories(duneistl INTERFACE)

add_subdirectory(cmake/modules)
add_subdirectory(dune)
add_subdirectory(doc)
add_subdirectory(src)

# if Python bindings are enabled, include necessary sub directories.
if( DUNE_ENABLE_PYTHONBINDINGS )
  add_subdirectory(python)
endif()

# finalize the dune project, e.g. generating config.h etc.
finalize_dune_project()

=== src/CMakeLists.txt ===
# SPDX-FileCopyrightText: Copyright © DUNE Project contributors, see file LICENSE.md in module root
# SPDX-License-Identifier: LicenseRef-GPL-2.0-only-with-DUNE-exception

dune_add_test(NAME istl-solver-playground
  SOURCES istl-solver-playground.cc LINK_LIBRARIES Dune::ISTL)
add_dune_mpi_flags(istl-solver-playground)
add_dune_parmetis_flags(istl-solver-playground)
dune_symlink_to_source_files(FILES playground.ini)

=== dune/istl/test/CMakeLists.txt ===
# SPDX-FileCopyrightText: Copyright © DUNE Project contributors, see file LICENSE.md in module root
# SPDX-License-Identifier: LicenseRef-GPL-2.0-only-with-DUNE-exception

# Link all test targets in this directory against Dune::ISTL
link_libraries(Dune::ISTL)

# install the test tools as we want to support testing 3rd-party vectors and matrices with an installed dune-istl
install(FILES
        matrixtest.hh
        vectortest.hh
        laplacian.hh
        multirhstest.hh
        DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/dune/istl/test)

dune_add_test(SOURCES bcrsassigntest.cc)

dune_add_test(SOURCES bcrsmatrixtest.cc)

dune_add_test(SOURCES bcrsnormtest.cc)

dune_add_test(SOURCES cgconditiontest.cc)

dune_add_test(SOURCES dilutest.cc)

dune_add_test(SOURCES dotproducttest.cc)

dune_add_test(SOURCES complexmatrixtest.cc)

dune_add_test(SOURCES fieldvectortest.cc)

dune_add_test(SOURCES foreachtest.cc)

dune_add_test(SOURCES matrixnormtest.cc)

dune_add_test(SOURCES matrixutilstest.cc)

dune_add_test(SOURCES matrixtest.cc)

dune_add_test(SOURCES multirhstest.cc)
add_dune_vc_flags(multirhstest) # Vc is not a hard requirement

dune_add_test(SOURCES bvectortest.cc)

dune_add_test(SOURCES vbvectortest.cc)

dune_add_test(SOURCES bcrsbuild.cc)

dune_add_test(SOURCES bcrsimplicitbuild.cc
              COMPILE_DEFINITIONS DUNE_ISTL_WITH_CHECKING=1)

dune_add_test(SOURCES matrixiteratortest.cc)

dune_add_test(SOURCES mmtest.cc)

dune_add_test(SOURCES multitypeblockmatrixtest.cc)

dune_add_test(SOURCES multitypeblockvectortest.cc)

dune_add_test(SOURCES mv.cc)

dune_add_test(SOURCES iotest.cc)

dune_add_test(SOURCES inverseoperator2prectest.cc)

dune_add_test(SOURCES preconditionerstest.cc)

dune_add_test(SOURCES scalarproductstest.cc)

dune_add_test(SOURCES scaledidmatrixtest.cc)

dune_add_test(SOURCES solvertest.cc)

dune_add_test(SOURCES solveraborttest.cc)

set(DUNE_TEST_FACTORY_FIELD_TYPES
  "double"
  "float"
  "std::complex<double>"
  "std::complex<float>"
  "Dune::LoopSIMD<double, 4>")

set(DUNE_TEST_FACTORY_BLOCK_SIZES
  1
  2
  3)

function(add_factory_test BLOCK)
  STRING(REGEX REPLACE "[^a-zA-Z0-9]" "" BLOCK_CLEAN ${BLOCK})
  set(DEFINE_DEACTIVATE_AMG_DIRECTSOLVER "#define DISABLE_AMG_DIRECTSOLVER 1")
  configure_file(solverfactorytest.cc.in solverfactorytest_${BLOCK_CLEAN}.cc)
  dune_add_test(NAME solverfactorytest_${BLOCK_CLEAN}
                SOURCES ${CMAKE_CURRENT_BINARY_DIR}/solverfactorytest_${BLOCK_CLEAN}.cc
                CMAKE_GUARD
                  HAVE_MPI
                  SuiteSparse_CHOLMOD_FOUND
                  SuiteSparse_LDL_FOUND
                  SuiteSparse_SPQR_FOUND
                  SuiteSparse_UMFPACK_FOUND
                  SuperLU_FOUND)
  add_dune_mpi_flags(solverfactorytest_${BLOCK_CLEAN})
  add_dune_parmetis_flags(solverfactorytest_${BLOCK_CLEAN})
  add_dune_suitesparse_flags(solverfactorytest_${BLOCK_CLEAN})
  add_dune_superlu_flags(solverfactorytest_${BLOCK_CLEAN})

  string(REGEX MATCH "LoopSIMD" _matched "${BLOCK}")
  if(NOT _matched)
    set(DEFINE_DEACTIVATE_AMG_DIRECTSOLVER "")
    configure_file(solverfactorytest.cc.in solverfactorytest_${BLOCK_CLEAN}_direct.cc)
    dune_add_test(NAME solverfactorytest_${BLOCK_CLEAN}_direct
                  SOURCES ${CMAKE_CURRENT_BINARY_DIR}/solverfactorytest_${BLOCK_CLEAN}_direct.cc
                  MPI_RANKS 1 2 4
                  TIMEOUT 600
                  CMAKE_GUARD
                    HAVE_MPI
                    SuiteSparse_CHOLMOD_FOUND
                    SuiteSparse_LDL_FOUND
                    SuiteSparse_SPQR_FOUND
                    SuiteSparse_UMFPACK_FOUND
                    SuperLU_FOUND)
    add_dune_mpi_flags(solverfactorytest_${BLOCK_CLEAN}_direct)
    add_dune_parmetis_flags(solverfactorytest_${BLOCK_CLEAN}_direct)
    add_dune_suitesparse_flags(solverfactorytest_${BLOCK_CLEAN}_direct)
    add_dune_superlu_flags(solverfactorytest_${BLOCK_CLEAN}_direct)
  endif()
endfunction(add_factory_test)

foreach(FIELD_TYPE ${DUNE_TEST_FACTORY_FIELD_TYPES})
  add_factory_test(${FIELD_TYPE})
  foreach(BLOCK_SIZE ${DUNE_TEST_FACTORY_BLOCK_SIZES})
    add_factory_test("Dune::FieldVector<${FIELD_TYPE}, ${BLOCK_SIZE}>")
  endforeach()
endforeach()
dune_symlink_to_source_files(FILES solverfactorytest.ini)

# SuperLU tests
if(HAVE_SUPERLU)
  dune_add_test(NAME superlustest
                SOURCES superlutest.cc
                COMPILE_DEFINITIONS SUPERLU_NTYPE=0)
  add_dune_superlu_flags(superlustest)

  dune_add_test(SOURCES superlutest.cc)
  add_dune_superlu_flags(superlutest)

  dune_add_test(NAME superluctest
                SOURCES superlutest.cc
                COMPILE_DEFINITIONS SUPERLU_NTYPE=2)
  add_dune_superlu_flags(superluctest)

  dune_add_test(NAME superluztest
                SOURCES superlutest.cc
                COMPILE_DEFINITIONS SUPERLU_NTYPE=3)
  add_dune_superlu_flags(superluztest)

  dune_add_test(SOURCES complexrhstest.cc
                COMPILE_DEFINITIONS SUPERLU_NTYPE=3)
  add_dune_superlu_flags(complexrhstest)
endif()

# SuiteSparse tests
if(HAVE_SUITESPARSE)
  dune_add_test(SOURCES umfpacktest.cc
              CMAKE_GUARD SuiteSparse_UMFPACK_FOUND)
  add_dune_suitesparse_flags(umfpacktest)
  set_directory_properties(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES "umfpack_decomp")

  dune_add_test(SOURCES ldltest.cc
                CMAKE_GUARD SuiteSparse_LDL_FOUND)
  add_dune_suitesparse_flags(ldltest)

  dune_add_test(SOURCES spqrtest.cc
                CMAKE_GUARD SuiteSparse_SPQR_FOUND)
  add_dune_suitesparse_flags(spqrtest)

  dune_add_test(SOURCES cholmodtest.cc
                CMAKE_GUARD SuiteSparse_CHOLMOD_FOUND)
  add_dune_suitesparse_flags(cholmodtest)
endif()

dune_add_test(SOURCES overlappingschwarztest.cc
              CMAKE_GUARD "SuperLU_FOUND OR SuiteSparse_UMFPACK_FOUND")
add_dune_suitesparse_flags(overlappingschwarztest)
add_dune_superlu_flags(overlappingschwarztest)

dune_add_test(SOURCES registrytest.cc)

# MPI tests
dune_add_test(SOURCES matrixredisttest.cc
              MPI_RANKS 1 2 4
              TIMEOUT 600
              CMAKE_GUARD MPI_FOUND)
add_dune_mpi_flags(matrixredisttest)
add_dune_parmetis_flags(matrixredisttest) # ParMETIS is not a hard requirement

dune_add_test(SOURCES vectorcommtest.cc
              MPI_RANKS 1 2 4
              TIMEOUT 600
              CMAKE_GUARD MPI_FOUND)
add_dune_mpi_flags(vectorcommtest)

dune_add_test(SOURCES matrixmarkettest.cc)
add_dune_gmp_flags(matrixmarkettest)
add_dune_mpi_flags(matrixmarkettest)
add_dune_quadmath_flags(matrixmarkettest)

dune_add_test(SOURCES iluildltest.cc)

dune_add_test(SOURCES matrixfreesolverfactorytest.cc)

dune_add_test(SOURCES blocklevel.cc COMPILE_ONLY)

dune_add_test(SOURCES registermacrosbackwardcompatibilitytest.cc
              CMAKE_GUARD "SuiteSparse_UMFPACK_FOUND")
add_dune_suitesparse_flags(registermacrosbackwardcompatibilitytest)

exclude_from_headercheck(complexdata.hh)

=== python/dune/istl/CMakeLists.txt ===
# SPDX-FileCopyrightText: Copyright © DUNE Project contributors, see file LICENSE.md in module root
# SPDX-License-Identifier: LicenseRef-GPL-2.0-only-with-DUNE-exception

add_python_targets(istl
  __init__
)
dune_add_pybind11_module(NAME _istl)
target_link_libraries(_istl PUBLIC Dune::ISTL)
if(SKBUILD)
  install(TARGETS _istl LIBRARY DESTINATION python/dune/istl)
endif()

=== dune/istl/eigenvalue/test/CMakeLists.txt ===
# SPDX-FileCopyrightText: Copyright © DUNE Project contributors, see file LICENSE.md in module root
# SPDX-License-Identifier: LicenseRef-GPL-2.0-only-with-DUNE-exception

# Link all test targets in this directory against Dune::ISTL
link_libraries(Dune::ISTL)

dune_add_test(NAME poweriterationtest SOURCES cond2test.cc
  CMD_ARGS 40)

if(SuperLU_FOUND)
  dune_add_test(NAME poweriterationsuperlutest SOURCES cond2test.cc
    CMD_ARGS 40)
  add_dune_superlu_flags(poweriterationsuperlutest)
endif()

if(ARPACKPP_FOUND)
  dune_add_test(NAME arpackpptest SOURCES cond2test.cc)
  add_dune_arpackpp_flags(arpackpptest)
endif()

if(ARPACKPP_FOUND AND SuperLU_FOUND)
  dune_add_test(NAME arpackppsuperlutest SOURCES cond2test.cc)
  add_dune_superlu_flags(arpackppsuperlutest)
  add_dune_arpackpp_flags(arpackppsuperlutest)
endif()

=== dune/istl/paamg/test/CMakeLists.txt ===
# SPDX-FileCopyrightText: Copyright © DUNE Project contributors, see file LICENSE.md in module root
# SPDX-License-Identifier: LicenseRef-GPL-2.0-only-with-DUNE-exception

# Link all test targets in this directory against Dune::ISTL
link_libraries(Dune::ISTL)

find_package(Threads)
if(CMAKE_USE_PTHREADS_INIT)
  dune_add_test(NAME pthreadamgtest SOURCES pthreadamgtest.cc
    LINK_LIBRARIES ${CMAKE_THREAD_LIBS_INIT}
    COMPILE_DEFINITIONS MYAMG=Dune::Amg::AMG<Operator,Vector,Smoother>)

  dune_add_test(NAME pthreadfastamgtest SOURCES pthreadamgtest.cc
    LINK_LIBRARIES ${CMAKE_THREAD_LIBS_INIT}
    COMPILE_DEFINITIONS MYAMG=Dune::Amg::FastAMG<Operator,Vector>)

  dune_add_test(NAME pthreadtwoleveltest SOURCES pthreadtwoleveltest.cc
    LINK_LIBRARIES ${CMAKE_THREAD_LIBS_INIT})

  dune_add_test(NAME pthreaddirectamgtest
                SOURCES pthreadamgtest.cc
                COMPILE_DEFINITIONS MYAMG=Dune::Amg::AMG<Operator,Vector,Smoother>
                LINK_LIBRARIES ${CMAKE_THREAD_LIBS_INIT}
                CMAKE_GUARD "SuperLU_FOUND OR SuiteSparse_UMFPACK_FOUND")
  add_dune_superlu_flags(pthreaddirectamgtest)
  add_dune_suitesparse_flags(pthreaddirectamgtest)

  dune_add_test(NAME pthreaddirectfastamgtest
                SOURCES pthreadamgtest.cc
                COMPILE_DEFINITIONS MYAMG=Dune::Amg::FastAMG<Operator,Vector>
                LINK_LIBRARIES ${CMAKE_THREAD_LIBS_INIT}
                CMAKE_GUARD "SuperLU_FOUND OR SuiteSparse_UMFPACK_FOUND")
  add_dune_superlu_flags(pthreaddirectfastamgtest)
  add_dune_suitesparse_flags(pthreaddirectfastamgtest)

  dune_add_test(NAME pthreaddirecttwoleveltest
                SOURCES pthreadtwoleveltest.cc
                LINK_LIBRARIES ${CMAKE_THREAD_LIBS_INIT}
                CMAKE_GUARD "SuperLU_FOUND OR SuiteSparse_UMFPACK_FOUND")
  add_dune_superlu_flags(pthreaddirecttwoleveltest)
  add_dune_suitesparse_flags(pthreaddirecttwoleveltest)
endif()

# add an executable without SuperLU/UMFPack
dune_add_test(NAME amgtest SOURCES amgtest.cc)

dune_add_test(NAME fastamg SOURCES fastamg.cc)

if(SuperLU_FOUND)
  dune_add_test(NAME superluamgtest SOURCES amgtest.cc)
  add_dune_superlu_flags(superluamgtest)

  dune_add_test(NAME superlufastamgtest SOURCES fastamg.cc)
  add_dune_superlu_flags(superlufastamgtest)
endif()

dune_add_test(NAME umfpackamgtest SOURCES amgtest.cc
              CMAKE_GUARD SuiteSparse_UMFPACK_FOUND)
add_dune_suitesparse_flags(umfpackamgtest)

dune_add_test(NAME umfpackfastamgtest SOURCES fastamg.cc
              CMAKE_GUARD SuiteSparse_UMFPACK_FOUND)
add_dune_suitesparse_flags(umfpackfastamgtest)

dune_add_test(SOURCES twolevelmethodtest.cc)

dune_add_test(SOURCES graphtest.cc)

dune_add_test(SOURCES kamgtest.cc)

dune_add_test(SOURCES transfertest.cc)

dune_add_test(NAME twolevelmethodschwarztest
              SOURCES twolevelmethodtest.cc
              COMPILE_DEFINITIONS USE_OVERLAPPINGSCHWARZ)

# These tests need MPI, even though they are only run sequentially
dune_add_test(SOURCES galerkintest.cc
              CMAKE_GUARD MPI_FOUND)
add_dune_mpi_flags(galerkintest)

dune_add_test(SOURCES hierarchytest.cc
              MPI_RANKS 1 2 4
              TIMEOUT 600
              CMAKE_GUARD MPI_FOUND)
add_dune_mpi_flags(hierarchytest)
add_dune_parmetis_flags(hierarchytest) # ParMETIS is not a hard requirement

dune_add_test(SOURCES coarsentest.cc
              MPI_RANKS 1 2 4
              TIMEOUT 600
              CMAKE_GUARD MPI_FOUND)
add_dune_mpi_flags(coarsentest)
add_dune_parmetis_flags(coarsentest) # ParMETIS is not a hard requirement

dune_add_test(NAME pamgtest
              SOURCES parallelamgtest.cc
              MPI_RANKS 1 2 4
              TIMEOUT 600
              CMAKE_GUARD MPI_FOUND)
add_dune_mpi_flags(pamgtest)
add_dune_parmetis_flags(pamgtest) # ParMETIS is not a hard requirement

dune_add_test(NAME pamg_comm_repart_test
              MPI_RANKS 1 2 4
              TIMEOUT 600
              SOURCES parallelamgtest.cc
              COMPILE_DEFINITIONS -DAMG_REPART_ON_COMM_GRAPH
              CMAKE_GUARD MPI_FOUND)
add_dune_mpi_flags(pamg_comm_repart_test)
add_dune_parmetis_flags(pamg_comm_repart_test) # ParMETIS is not a hard requirement

dune_add_test(NAME pamgmmtest
  SOURCES pamgmmtest.cc
  TIMEOUT 20
  MPI_RANKS 6
  CMAKE_GUARD "(HAVE_MPI AND HAVE_PARMETIS)")
add_dune_mpi_flags(pamgmmtest)
add_dune_parmetis_flags(pamgmmtest)

file(COPY gr_30_30.mm DESTINATION ${CMAKE_CURRENT_BINARY_DIR})

=== debian/changelog ===
dune-istl (2.11.0-1) unstable; urgency=medium

  * New upstream release 2.11.0
  * Added gbp.conf for dep-14 branch layout
  * Added Salsa ci configuration alsa-ci.yml
  * Updated debian/copyright
  * d/patches: Removed patches already applied upstream.
  * d/control: Depend on dune-common >= 2.11~

 -- Markus Blatt <markus@dr-blatt.de>  Fri, 06 Feb 2026 17:25:13 +0100

dune-istl (2.11.0-1~exp1) experimental; urgency=medium

  * New upstream release 2.11.0
  * Added gbp.conf for dep-14 branch layout
  * Added Salsa ci configuration alsa-ci.yml
  * Update changelog for 2.11.0-1~1.gbp8ec198 release

 -- Markus Blatt <markus@dr-blatt.de>  Wed, 28 Jan 2026 16:05:30 +0100

=== debian/control ===
Source: dune-istl
Section: libs
Priority: optional
Standards-Version: 4.7.0
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Ansgar <ansgar@debian.org>, Markus Blatt <markus@dr-blatt.de>
Vcs-Browser: https://salsa.debian.org/science-team/dune-istl
Vcs-Git: https://salsa.debian.org/science-team/dune-istl.git
Homepage: https://www.dune-project.org/
Build-Depends: debhelper-compat (= 13),
 cmake (>= 3.13), gfortran, mpi-default-bin, mpi-default-dev, pkgconf, python3,
 libdune-common-dev (>= 2.11~),
 libsuitesparse-dev [!armel !armhf !i386 !hppa !hurd-i386 !powerpc !x32],
 libsuperlu-dev
Build-Depends-Indep: doxygen, ghostscript, graphviz, imagemagick, texlive-latex-extra, texlive-latex-recommended, texlive-pictures
Rules-Requires-Root: no

Package: libdune-istl-dev
Section: libdevel
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends}, libdune-common-dev (>= 2.11~),
 libsuitesparse-dev [!armel !armhf !hppa !hurd-i386 !powerpc !x32],
 libsuperlu-dev
Suggests: libdune-istl-doc (= ${source:Version})
Description: toolbox for solving PDEs -- iterative solvers (development files)
 DUNE, the Distributed and Unified Numerics Environment is a modular toolbox
 for solving partial differential equations (PDEs) with grid-based methods.
 It supports the easy implementation of methods like Finite Elements (FE),
 Finite Volumes (FV), and also Finite Differences (FD).
 .
 This package contains the development files for the iterative solver template
 library.

Package: libdune-istl-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Built-Using: ${dune:doc:Built-Using}
Description: toolbox for solving PDEs -- iterative solvers (documentation)
 DUNE, the Distributed and Unified Numerics Environment is a modular toolbox
 for solving partial differential equations (PDEs) with grid-based methods.
 It supports the easy implementation of methods like Finite Elements (FE),
 Finite Volumes (FV), and also Finite Differences (FD).
 .
 This package contains the documentation for the iterative solver template
 library.
